(use test accents-substitute-utf8)

(test-begin "UTF8 -> ASCII")
(test "-a-" (accents-substitute "-ã-"))
(test "-A-" (accents-substitute "-Ã-"))
(test "-a-" (accents-substitute "-á-"))
(test "-A-" (accents-substitute "-Á-"))
(test "-a-" (accents-substitute "-â-"))
(test "-A-" (accents-substitute "-Â-"))
(test "-a-" (accents-substitute "-à-"))
(test "-A-" (accents-substitute "-À-"))
(test "-a-" (accents-substitute "-ä-"))
(test "-A-" (accents-substitute "-Ä-"))
(test "-e-" (accents-substitute "-é-"))
(test "-E-" (accents-substitute "-É-"))
(test "-e-" (accents-substitute "-ê-"))
(test "-E-" (accents-substitute "-Ê-"))
(test "-e-" (accents-substitute "-è-"))
(test "-E-" (accents-substitute "-È-"))
(test "-e-" (accents-substitute "-ë-"))
(test "-E-" (accents-substitute "-Ë-"))
(test "-i-" (accents-substitute "-í-"))
(test "-I-" (accents-substitute "-Í-"))
(test "-i-" (accents-substitute "-î-"))
(test "-I-" (accents-substitute "-Î-"))
(test "-i-" (accents-substitute "-ì-"))
(test "-I-" (accents-substitute "-Ì-"))
(test "-i-" (accents-substitute "-ï-"))
(test "-I-" (accents-substitute "-Ï-"))
(test "-o-" (accents-substitute "-õ-"))
(test "-O-" (accents-substitute "-Õ-"))
(test "-o-" (accents-substitute "-ó-"))
(test "-O-" (accents-substitute "-Ó-"))
(test "-o-" (accents-substitute "-ô-"))
(test "-O-" (accents-substitute "-Ô-"))
(test "-o-" (accents-substitute "-ò-"))
(test "-O-" (accents-substitute "-Ò-"))
(test "-o-" (accents-substitute "-ö-"))
(test "-O-" (accents-substitute "-Ö-"))
(test "-u-" (accents-substitute "-ú-"))
(test "-U-" (accents-substitute "-Ú-"))
(test "-u-" (accents-substitute "-û-"))
(test "-U-" (accents-substitute "-Û-"))
(test "-u-" (accents-substitute "-ù-"))
(test "-U-" (accents-substitute "-Ù-"))
(test "-u-" (accents-substitute "-ü-"))
(test "-U-" (accents-substitute "-Ü-"))
(test "-c-" (accents-substitute "-ç-"))
(test "-C-" (accents-substitute "-Ç-"))
(test "-CC-" (accents-substitute "-ÇÇ-"))
(test-end "UTF8 -> ASCII")

(test-begin "UTF8 -> HTML")
(test "-&atilde;-" (accents-substitute "-ã-" mode: 'html))
(test "-&Atilde;-" (accents-substitute "-Ã-" mode: 'html))
(test "-&aacute;-" (accents-substitute "-á-" mode: 'html))
(test "-&Aacute;-" (accents-substitute "-Á-" mode: 'html))
(test "-&acirc;-"  (accents-substitute "-â-" mode: 'html))
(test "-&Acirc;-"  (accents-substitute "-Â-" mode: 'html))
(test "-&agrave;-" (accents-substitute "-à-" mode: 'html))
(test "-&Agrave;-" (accents-substitute "-À-" mode: 'html))
(test "-&auml;-"   (accents-substitute "-ä-" mode: 'html))
(test "-&Auml;-"   (accents-substitute "-Ä-" mode: 'html))
(test "-&eacute;-" (accents-substitute "-é-" mode: 'html))
(test "-&Eacute;-" (accents-substitute "-É-" mode: 'html))
(test "-&ecirc;-"  (accents-substitute "-ê-" mode: 'html))
(test "-&Ecirc;-"  (accents-substitute "-Ê-" mode: 'html))
(test "-&egrave;-" (accents-substitute "-è-" mode: 'html))
(test "-&Egrave;-" (accents-substitute "-È-" mode: 'html))
(test "-&euml;-"   (accents-substitute "-ë-" mode: 'html))
(test "-&Euml;-"   (accents-substitute "-Ë-" mode: 'html))
(test "-&iacute;-" (accents-substitute "-í-" mode: 'html))
(test "-&Iacute;-" (accents-substitute "-Í-" mode: 'html))
(test "-&icirc;-"  (accents-substitute "-î-" mode: 'html))
(test "-&Icirc;-"  (accents-substitute "-Î-" mode: 'html))
(test "-&igrave;-" (accents-substitute "-ì-" mode: 'html))
(test "-&Igrave;-" (accents-substitute "-Ì-" mode: 'html))
(test "-&iuml;-"   (accents-substitute "-ï-" mode: 'html))
(test "-&Iuml;-"   (accents-substitute "-Ï-" mode: 'html))
(test "-&otilde;-" (accents-substitute "-õ-" mode: 'html))
(test "-&Otilde;-" (accents-substitute "-Õ-" mode: 'html))
(test "-&oacute;-" (accents-substitute "-ó-" mode: 'html))
(test "-&Oacute;-" (accents-substitute "-Ó-" mode: 'html))
(test "-&ocirc;-"  (accents-substitute "-ô-" mode: 'html))
(test "-&Ocirc;-"  (accents-substitute "-Ô-" mode: 'html))
(test "-&ograve;-" (accents-substitute "-ò-" mode: 'html))
(test "-&Ograve;-" (accents-substitute "-Ò-" mode: 'html))
(test "-&ouml;-"   (accents-substitute "-ö-" mode: 'html))
(test "-&Ouml;-"   (accents-substitute "-Ö-" mode: 'html))
(test "-&uacute;-" (accents-substitute "-ú-" mode: 'html))
(test "-&Uacute;-" (accents-substitute "-Ú-" mode: 'html))
(test "-&ucirc;-"  (accents-substitute "-û-" mode: 'html))
(test "-&Ucirc;-"  (accents-substitute "-Û-" mode: 'html))
(test "-&ugrave;-" (accents-substitute "-ù-" mode: 'html))
(test "-&Ugrave;-" (accents-substitute "-Ù-" mode: 'html))
(test "-&uuml;-"   (accents-substitute "-ü-" mode: 'html))
(test "-&Uuml;-"   (accents-substitute "-Ü-" mode: 'html))
(test "-&ccedil;-" (accents-substitute "-ç-" mode: 'html))
(test "-&Ccedil;-" (accents-substitute "-Ç-" mode: 'html))
(test "-&Ccedil;&Ccedil;-" (accents-substitute "-ÇÇ-" mode: 'html))
(test-end "UTF8 -> HTML")